﻿var Events = MindFusion.Diagramming.Events;
var Diagram = MindFusion.Diagramming.Diagram;
var DiagramLink = MindFusion.Diagramming.DiagramLink;
var ShapeNode = MindFusion.Diagramming.ShapeNode;
var AnchorPattern = MindFusion.Diagramming.AnchorPattern;
var AnchorPoint = MindFusion.Diagramming.AnchorPoint;
var MarkStyle = MindFusion.Diagramming.MarkStyle;
var GlassEffect = MindFusion.Diagramming.GlassEffect;

var Rect = MindFusion.Drawing.Rect;

var Dictionary = MindFusion.Collections.Dictionary;
var mdiag = MindFusion.Diagramming;

var diagram = null;
var bounds = new Rect(0, 0, 30, 6);
var brush = "LightBlue";

var decision1In3Out, apat2;

$(document).ready(function (sender, args)
{

	Diagram.prototype.registerXmlTypes = function ()
	{
		var xmlClassMap = new Dictionary();

		function register(ctor, classId, classVersion)
		{
			xmlClassMap[classId] = ctor;
			ctor.xmlInfo = { classId: classId, classVersion: classVersion };
		}

		register(mdiag.DiagramLink, "std:DiagramLink", 2);
		register(mdiag.ShapeNode, "std:ShapeNode", 1);
		register(mdiag.TableNode, "std:TableNode", 1);
		register(mdiag.ContainerNode, "std:ContainerNode", 3);
		register(mdiag.SvgNode, "std:SvgNode", 2);
		register(mdiag.FreeFormNode, "std:FreeFormNode", 1);

		register(mdiag.GlassEffect, "std:GlassEffect", 1);
		register(mdiag.AeroEffect, "std:AeroEffect", 1);

		register(CustomNode, "ns:CustomNode", 1);
		register(CustomLink, "ns:CustomLink", 1);


		return xmlClassMap;
	};

	// create a Diagram component that wraps the "diagram" canvas
	diagram = Diagram.create($("#diagram")[0]);

	MindFusion.AbstractionLayer.registerClass(CustomNode, "CustomNode", MindFusion.Diagramming.ShapeNode);
	MindFusion.AbstractionLayer.registerClass(CustomLink, "CustomLink", MindFusion.Diagramming.DiagramLink);

	diagram.loadFromXml(
		"template.xml",
		function () { alert("ready") },
		function () { alert("error") }
		);

});

var CustomNode = function (parent)
{
	MindFusion.AbstractionLayer.initializeBase(CustomNode, this, [parent]);
}


var CustomLink = function (parent, origin, destination)
{
	MindFusion.AbstractionLayer.initializeBase(CustomLink, this, [parent, origin, destination]);
}
